/*
***************************************************************************
Nouvelle version  30/03/2002
        ajout :
                Proprit visible

***************************************************************************
TFleches 1.20
Copyright  2001 Pascal Guerdin
License
-------
TFleche est distribu comme un freeware. Vous tes libres  de l'employer
comme partie de votre application pour tout but incluant freeware,
publicit et shareware applications.
Je vous demande juste de faire apparatre mon nom  quelque part dans le
code source.
Aucune garantie n'est donn par l'auteur, exprim ou impliqu
Dsaveu
-------
je ne prends aucune responsabilit pour toute perte souffrant ou
rsultant d'emploi ou abus de ce code.  Il est
freeware, avec le code source, et si vous employez (ou
modifier le code),l'utilisation est  votre propre risque.
Par contre pour toutes modifications ou amliorations du code je vous pris
de me prvenir afin de mettre  jour le composant de base.
J'espre qu'il vous apportera satisfaction
Et toutes les suggestions seront les bienvenues.
Amicalement
Pascal

Auteur
------
Pascal Guerdin
Guerpa@Club-Internet.fr
***************************************************************************
*************************************************************************** */

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Fleches.h"
#include "math.h"
#include "Math.hpp"
#include "Actnlist.hpp"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck est utilis est utilis pour tre sr que les composants crs n'ont
// aucune fonction virtuelle pure.
//

static inline void ValidCtrCheck(TFleches *)
{
        new TFleches(NULL);
}

//---------------------------------------------------------------------------
__fastcall TFleches::TFleches(TComponent* Owner)
        : TGraphicControl(Owner)
{
        OnCreate = SiCreate;
	FStyleLigne = new TPen();
	FStyleFondLigne = new TBrush();
        OnResize  = StyleChange;
        OnClick  =  StyleChange;
        //FVisible =true;
        FStyleFondLigne->OnChange = StyleChange;
        FStyleLigne->OnChange = StyleChange;
        //---Dfinition de la ligne
        StyleLigne->Color = clYellow;
        StyleLigne->Width = 1;
        //---Dfinition de la taille du composant
        Height = 100;
        Width = 100;
        //---Dfinition de la pointe n 1
        Pointe1Couleur = clYellow;
        Pointe1Epaisseur = 1;
        Pointe1Longueur = 20;
        Pointe1Largeur = 20;
        //---Dfinition de la pointe n 2
        Pointe2Couleur = clYellow;
        Pointe2Epaisseur = 1;
        Pointe2Longueur = 20;
        Pointe2Largeur = 20;
}
//---------------------------------------------------------------------------
namespace Fleches
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TFleches)};
                 RegisterComponents("CPEAO", classes, 0);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::InitialiseFleche()
{
	Canvas->Lock();
        ConstruitLigne();
        ConstruitPointe();
        Canvas->Brush->Color = StyleFondLigne->Color;
	Canvas->Brush->Style = StyleFondLigne->Style;
	Canvas->Unlock();
}
//---------------------------------------------------------------------------

void __fastcall TFleches::ConstruitLigne()
{

        PointCentral.X = Width / 2;
        PointCentral.Y = Height / 2;

        if ((PositionLigne == 8 || PositionLigne == 9) && (PositionPointe != 3))
                PositionPointe = Doubles;
        //----defini les points de dpart et d'arriv de la ligne
	switch (PositionPointe)
        {
                case 0: //Double
                        PointContactHaut.X = Width / 2;
                        PointContactHaut.Y = Pointe1Longueur;
                        PointContactBas.X = Width / 2;
                        PointContactBas.Y = Height - Pointe2Longueur;
                        PointContactGauche.X = Pointe1Longueur;
                        PointContactGauche.Y = Height / 2;
                        PointContactDroite.X = Width - Pointe2Longueur;
                        PointContactDroite.Y = Height / 2;
                        DefineDiag(0);
                        DessineLigne();
                        break;
                case 1: //Gauche
                        PointContactHaut.X = Width / 2 ;
                        PointContactHaut.Y = Pointe1Longueur;
                        PointContactBas.X = Width / 2;
                        PointContactBas.Y = Height;
                        PointContactGauche.X = Pointe1Longueur;
                        PointContactGauche.Y = Height / 2;
                        PointContactDroite.X = Width;
                        PointContactDroite.Y = Height / 2;
                        DefineDiag(1);
                        DessineLigne();
                        break;
                case 2: //Droite
                        PointContactHaut.X = Width / 2 ;
                        PointContactHaut.Y = 0;
                        PointContactBas.X = Width / 2;
                        PointContactBas.Y = Height  - Pointe1Longueur ;
                        PointContactGauche.X = 0;
                        PointContactGauche.Y = Height / 2;
                        PointContactDroite.X = Width - Pointe1Longueur;
                        PointContactDroite.Y = Height / 2;
                        DefineDiag(2);
                        DessineLigne();
                        break;
                case 3: //Sans
                        PointContactHaut.X = Width / 2 ;
                        PointContactHaut.Y = 0;
                        PointContactBas.X = Width / 2;
                        PointContactBas.Y = Height ;
                        PointContactGauche.X = 0;
                        PointContactGauche.Y = Height / 2;
                        PointContactDroite.X = Width;
                        PointContactDroite.Y = Height / 2;
                        PointContactDGH.X = 0;
                        PointContactDGH.Y = 0;
                        PointContactDDB.X = Width ;
                        PointContactDDB.Y = Height ;
                        PointContactDGB.X = 0 ;
                        PointContactDGB.Y = Height ;
                        PointContactDDH.X = Width  ;
                        PointContactDDH.Y = 0 ;
                        DessineLigne();
                        break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::DefineDiag(int PosPointe)
{
        switch (PosPointe)
	{
		case 0:
                       if (Width <= Height)
                       {
                                  AngleLigne = ArcTan2(Height ,Width);
                                  PointContactDGH.X = Pointe1Longueur * (cos(AngleLigne));
                                  PointContactDGH.Y = Pointe1Longueur * (sin(AngleLigne)) ;
                                  PointContactDDB.X = Width - (Pointe2Longueur * (cos(AngleLigne)));
                                  PointContactDDB.Y = Height - (Pointe2Longueur * (sin(AngleLigne))) ;
                                  PointContactDGB.X = Pointe1Longueur * (cos(AngleLigne)) ;
                                  PointContactDGB.Y = Height - (Pointe1Longueur * (sin(AngleLigne))) ;
                                  PointContactDDH.X = Width  - (Pointe2Longueur * (cos(AngleLigne))) ;
                                  PointContactDDH.Y = Pointe2Longueur * (sin(AngleLigne)) ;
                        }
                        else
                        {
                                  AngleLigne = ArcTan2(Width ,Height);
                                  PointContactDGH.X = Pointe1Longueur * (sin(AngleLigne));
                                  PointContactDGH.Y = Pointe1Longueur * (cos(AngleLigne));
                                  PointContactDDB.X = Width - (Pointe2Longueur * (sin(AngleLigne)));
                                  PointContactDDB.Y = Height - (Pointe2Longueur * (cos(AngleLigne)));
                                  PointContactDGB.X = Pointe1Longueur * (sin(AngleLigne)) ;
                                  PointContactDGB.Y = Height - (Pointe1Longueur * (cos(AngleLigne))) ;
                                  PointContactDDH.X = Width  - (Pointe2Longueur * (sin(AngleLigne))) ;
                                  PointContactDDH.Y = Pointe2Longueur * (cos(AngleLigne)) ;
                        }

                        if (Pointe2Forme == 1 || Pointe2Forme == 2)
                        {
                                  PointContactDDB.X = Width  - Pointe2Longueur ;
                                  PointContactDDB.Y = Height - Pointe2Largeur ;
                                  PointContactDDH.X = Width  - Pointe2Longueur ;
                                  PointContactDDH.Y = Pointe2Largeur ;
                        }
                        if (Pointe1Forme == 1 || Pointe1Forme == 2)
                        {
                                  PointContactDGH.X = Pointe1Longueur ;
                                  PointContactDGH.Y = Pointe1Largeur ;
                                  PointContactDGB.X = Pointe1Longueur ;
                                  PointContactDGB.Y = Height - Pointe1Largeur ;
                        }
			break;
		case 1:
                        if (Pointe1Forme == 1 || Pointe1Forme == 2)
                        {
                                  PointContactDGH.X = Pointe1Longueur ;
                                  PointContactDGH.Y = Pointe1Largeur ;
                                  PointContactDGB.X = Pointe1Longueur ;
                                  PointContactDGB.Y = Height - Pointe1Largeur ;
                        }
                        else
                        {
                                  if (Width <= Height)
                                  {
                                            AngleLigne = ArcTan2(Height ,Width);
                                            PointContactDGH.X = Pointe1Longueur * (cos(AngleLigne));
                                            PointContactDGH.Y = Pointe1Longueur * (sin(AngleLigne)) ;
                                            PointContactDGB.X = Pointe1Longueur * (cos(AngleLigne)) ;
                                            PointContactDGB.Y = Height - (Pointe1Longueur * (sin(AngleLigne))) ;
                                  }
                                  else
                                  {
                                            AngleLigne = ArcTan2(Width ,Height);
                                            PointContactDGH.X = Pointe1Longueur * (sin(AngleLigne));
                                            PointContactDGH.Y = Pointe1Longueur * (cos(AngleLigne));
                                            PointContactDGB.X = Pointe1Longueur * (sin(AngleLigne)) ;
                                            PointContactDGB.Y = Height - (Pointe1Longueur * (cos(AngleLigne))) ;
                                  }
                        }
                        PointContactDDB.X = Width ;
                        PointContactDDB.Y = Height ;
                        PointContactDDH.X = Width ;
                        PointContactDDH.Y = 0 ;
                 	break;
		case 2:
                        if (Pointe1Forme == 1 || Pointe1Forme == 2)
                        {
                                  PointContactDDB.X = Width - Pointe1Longueur;
                                  PointContactDDB.Y = Height - Pointe1Largeur;
                                  PointContactDDH.X = Width  - Pointe1Longueur ;
                                  PointContactDDH.Y = Pointe1Largeur ;
                        }
                        else
                        {
                                  if (Width <= Height)
                                  {
                                            AngleLigne = ArcTan2(Height ,Width);
                                            PointContactDDB.X = Width - (Pointe1Longueur * (cos(AngleLigne)));
                                            PointContactDDB.Y = Height - (Pointe1Longueur * (sin(AngleLigne))) ;
                                            PointContactDDH.X = Width - (Pointe1Longueur * (cos(AngleLigne)));
                                            PointContactDDH.Y = Pointe1Longueur * (sin(AngleLigne)) ;
                                  }
                                  else
                                  {
                                            AngleLigne = ArcTan2(Width ,Height);
                                            PointContactDDB.X = Width - (Pointe1Longueur * (sin(AngleLigne)));
                                            PointContactDDB.Y = Height - (Pointe1Longueur * (cos(AngleLigne)));
                                            PointContactDDH.X = Width - (Pointe1Longueur * (sin(AngleLigne)));
                                            PointContactDDH.Y = Pointe1Longueur * (cos(AngleLigne));
                                  }
                        }
                        PointContactDGH.X = 0 ;
                        PointContactDGH.Y = 0 ;
                        PointContactDGB.X = 0 ;
                        PointContactDGB.Y = Height ;
			break;

		default:
			break ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::DessineLigne()
{
        switch (PositionLigne)
        {
                case 0: //Verticale
                        Canvas->MoveTo(PointContactHaut.X,PointContactHaut.Y);
                        Canvas->LineTo(PointContactBas.X,PointContactBas.Y);
                        break;
                case 1: //Horizontale
                        Canvas->MoveTo(PointContactGauche.X,PointContactGauche.Y);
                        Canvas->LineTo(PointContactDroite.X,PointContactDroite.Y);
                        break;
                case 2: //Diagonale Droite
                        Canvas->MoveTo(PointContactDGB.X,PointContactDGB.Y);
                        Canvas->LineTo(PointContactDDH.X, PointContactDDH.Y);
                        break;
                case 3: //Diagonale Gauche
                        Canvas->MoveTo(PointContactDGH.X,PointContactDGH.Y);
                        Canvas->LineTo(PointContactDDB.X, PointContactDDB.Y);
                        break;
                case 4: //Coude Droite Haut
                        Canvas->MoveTo(PointContactHaut.X,PointContactHaut.Y);
                        Canvas->LineTo( PointCentral.X, PointCentral.Y);
                        Canvas->LineTo(PointContactDroite.X,PointContactDroite.Y);
                        break;
                case 5: //Coude Gauche Haut
                        if(PositionPointe == 0 )PointContactHaut.Y = Pointe2Longueur;
                        if(PositionPointe == 1 )PointContactHaut.Y = 0;
                        if(PositionPointe == 2 )PointContactHaut.Y = Pointe1Longueur;
                        Canvas->MoveTo(PointContactHaut.X,PointContactHaut.Y);
                        Canvas->LineTo( PointCentral.X, PointCentral.Y);
                        Canvas->LineTo(PointContactGauche.X,PointContactGauche.Y);
                        break;
                case 6: //Coude Droite Bas
                        if(PositionPointe == 0 )PointContactBas.Y = Height - Pointe1Longueur;
                        if(PositionPointe == 1 )PointContactBas.Y = Height - Pointe1Longueur;
                        if(PositionPointe == 2 )PointContactBas.Y = Height;
                        Canvas->MoveTo(PointContactBas.X,PointContactBas.Y);
                        Canvas->LineTo( PointCentral.X, PointCentral.Y);
                        Canvas->LineTo(PointContactDroite.X,PointContactDroite.Y);
                        break;
                case 7: //Coude Gauche Bas
                        Canvas->MoveTo(PointContactBas.X,PointContactBas.Y);
                        Canvas->LineTo( PointCentral.X, PointCentral.Y);
                        Canvas->LineTo(PointContactGauche.X,PointContactGauche.Y);
                        break;
                case 8: //Complte Droite
                        Canvas->MoveTo(PointContactHaut.X,PointContactHaut.Y);
                        Canvas->LineTo( PointContactBas.X,PointContactBas.Y);
                        Canvas->MoveTo(PointContactGauche.X,PointContactGauche.Y);
                        Canvas->LineTo( PointContactDroite.X,PointContactDroite.Y);
                        break;
                case 9: //Complete Diagonale
                        Canvas->MoveTo(PointContactDGH.X,PointContactDGH.Y);
                        Canvas->LineTo( PointContactDDB.X,PointContactDDB.Y);
                        Canvas->MoveTo(PointContactDDH.X,PointContactDDH.Y);
                        Canvas->LineTo( PointContactDGB.X,PointContactDGB.Y);
                        break;
                default:
                        break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::Paint()
{
        inherited Paint();
        Canvas->Brush->Style = bsClear;
        Canvas->Pen->Style = psClear;
        Canvas->Pen->Color = StyleLigne->Color;
        Canvas->Pen->Width = StyleLigne->Width ;
        Canvas->Pen->Style = StyleLigne->Style ;
        Canvas->Pen->Mode = StyleLigne->Mode ;
        Canvas->Brush->Color = StyleFondLigne->Color;
        Canvas->Brush->Style = StyleFondLigne->Style;
	InitialiseFleche();
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPositionLigne(TFPositionLigne value)
{
        if(FPositionLigne != value) {
                FPositionLigne = value;
                if ((value == 8 || value == 9) && (PositionPointe != 3))
                        PositionPointe = Doubles;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe1Forme(TFFormePointe value)
{
        if(FPointe1Forme != value) {
                FPointe1Forme = value;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Forme(TFFormePointe value)
{
        if(FPointe2Forme != value) {
                FPointe2Forme = value;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------
void __fastcall TFleches::SetPointe1Longueur(int value)
{
        if(FPointe1Longueur != value) {
		FPointe1Longueur = value;
		StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe1Largeur(int value)
{
        if(FPointe1Largeur != value) {
                FPointe1Largeur = value;
		StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Largeur(int value)
{
        if(FPointe2Largeur != value) {
                FPointe2Largeur = value;
		StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Longueur(int value)
{
        if(FPointe2Longueur != value) {
                FPointe2Longueur = value;
		StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe1Couleur(TColor value)
{
        if(FPointe1Couleur != value) {
		FPointe1Couleur = value;
		StyleChange(this);
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Couleur(TColor value)
{
	if(FPointe2Couleur != value) {
		FPointe2Couleur = value;
		StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe1Epaisseur(int value)
{
        if(FPointe1Epaisseur != value) {
                FPointe1Epaisseur = value;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Epaisseur(int value)
{
        if(FPointe2Epaisseur != value) {
                FPointe2Epaisseur = value;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPositionPointe(TFPositionPointe value)
{
        if(FPositionPointe != value) {
                FPositionPointe = value;
                StyleChange(this);
        }
}
//---------------------------------------------------------------------------

void __fastcall TFleches::ConstruitPointe()
{
        switch (PositionPointe)
        {
                case 0: //Pointe Doubles
                        if (PositionLigne == 8 || PositionLigne == 9)
                        {
                                if (PositionLigne == 8)
                                {
				       DessinePointe1(1,1);
                                       DessinePointe2(1);
				       DessinePointe1(4,1);
				       DessinePointe2(7);
                                }
                                if (PositionLigne == 9)
                                {
                                       DessinePointe1(2,1);
                                       DessinePointe2(2);
                                       DessinePointe1(3,1);
                                       DessinePointe2(3);
                                }
                        }
                        else
                        {
                                DessinePointe1(PositionLigne,1);
                                DessinePointe2(PositionLigne);
                        }
                        break;
		case 1: //Pointe Gauche
			DessinePointe1(PositionLigne,1);
			break;
		case 2: //Pointe Droite
			DessinePointe1(PositionLigne,2);
			break;
		case 3: //Sans Pointe
			break;
		default: break;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::DessinePointe1(int APosLigne ,int Place)
{
	int DepPointeX , DepPointeY, FinPointeX, FinPointeY;

	Canvas->Brush->Color = Pointe1Couleur;
	Canvas->Pen->Style = StyleLigne->Style;
        Canvas->Pen->Width = Pointe1Epaisseur;

	if (Pointe1Type == 0)
		Canvas->Brush->Style = bsSolid;
	else
		Canvas->Brush->Style = bsClear;
	//********************************
	//Place : 1 = Gauche  2 = Droite//
	if (Place == 1)             //initialise la forme
	{
		switch (APosLigne)  //Position Par Rapport  La Ligne
		{
		  case 0:
			DepPointeX  = PointContactHaut.X -(Pointe1Largeur / 2);
			DepPointeY = 0 ;
			FinPointeX = PointContactHaut.X + (Pointe1Largeur/2) ;
			FinPointeY = PointContactHaut.Y;
			break;
		  case 1:
			DepPointeX = 0;
			DepPointeY = PointContactGauche.Y -(Pointe1Largeur / 2) ;
			FinPointeX = PointContactGauche.X;
			FinPointeY = PointContactGauche.Y + (Pointe1Largeur/2);
			break;
		  case 2:
			DepPointeX = 0;
			DepPointeY = Height ;
			FinPointeX = PointContactDGB.X;
			FinPointeY = PointContactDGB.Y ;
			break;
		  case 3:
			DepPointeX = 0;
			DepPointeY = 0 ;
			FinPointeX = PointContactDGH.X;
			FinPointeY = PointContactDGH.Y ;
			break;
		  case 4:
			DepPointeX  = PointContactHaut.X -(Pointe1Largeur / 2) ;
			DepPointeY = 0;
			FinPointeX = PointContactHaut.X +(Pointe1Largeur / 2) ;
			FinPointeY = PointContactHaut.Y ;
			break;
		  case 5:
			DepPointeX  = 0 ;
			DepPointeY = PointContactGauche.Y -(Pointe1Largeur / 2);
			FinPointeX = PointContactGauche.X  ;
			FinPointeY = PointContactGauche.Y +(Pointe1Largeur / 2);
			break;
		  case 6:
			DepPointeX  = PointContactBas.X -(Pointe1Largeur / 2) ;
			DepPointeY = PointContactBas.Y;
			FinPointeX = PointContactBas.X +(Pointe1Largeur / 2) ;
			FinPointeY = Height ;
			break;
		  case 7:
			DepPointeX  = 0 ;
			DepPointeY = PointContactGauche.Y -(Pointe1Largeur / 2);
			FinPointeX = PointContactGauche.X  ;
			FinPointeY = PointContactGauche.Y +(Pointe1Largeur / 2);
			break;
		  default:
			break;
		}
	}
	else
	{
		switch (APosLigne)  //Poisition Par Rapport  La Ligne
		{
		  case 0:
			DepPointeX  = PointContactBas.X -(Pointe1Largeur / 2);
			DepPointeY = PointContactBas.Y ;
			FinPointeX = PointContactBas.X + (Pointe1Largeur/2) ;
			FinPointeY = Height;
			break;
		  case 1:
			DepPointeX  = PointContactDroite.X;
			DepPointeY = PointContactDroite.Y -(Pointe1Largeur / 2) ;
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe1Largeur / 2) ;
			break;
		  case 2:
                        DepPointeX = PointContactDDH.X;
			DepPointeY = PointContactDDH.Y ;
			FinPointeX = Width;
			FinPointeY = 0;
		        break;
		  case 3:
		        DepPointeX = PointContactDDB.X;
			DepPointeY = PointContactDDB.Y ;
			FinPointeX = Width;
			FinPointeY = Height;
			break;
		  case 4:
			DepPointeX = PointContactDroite.X ;
			DepPointeY = PointContactDroite.Y -(Pointe1Largeur / 2);
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe1Largeur / 2);
			break;
		  case 5:
			DepPointeX  = PointContactHaut.X -(Pointe1Largeur / 2) ;
			DepPointeY = 0;
			FinPointeX = PointContactHaut.X +(Pointe1Largeur / 2) ;
			FinPointeY = PointContactHaut.Y ;
			break;
		  case 6:
			DepPointeX = PointContactDroite.X ;
			DepPointeY = PointContactDroite.Y -(Pointe1Largeur / 2);
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe1Largeur / 2);
			break;
		  case 7:
                        DepPointeX  = PointContactBas.X -(Pointe1Largeur / 2) ;
			DepPointeY = PointContactBas.Y;
			FinPointeX = PointContactBas.X +(Pointe1Largeur / 2) ;
			FinPointeY = Height ;
			break;
		  default:
			break;
		}
	}
	TRect Form;
	Form = Rect(DepPointeX,DepPointeY,FinPointeX,FinPointeY);
	//**************************
	switch (Pointe1Forme)     //Dessine la forme
	{
	  case 0://Classic
                Canvas->Polygon(CreePointe(APosLigne,Place),2);
		break;
	  case 1://Ronde
		Canvas->Ellipse(Form);
		break;
	  case 2://Carre
		Canvas->Rectangle(Form);
		break;
	  case 3://Losange
	       	Canvas->Polygon(CreeLosange(APosLigne,Place),3);
		break;
	  default:
		break ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::DessinePointe2(int APosLigne)
{
	int DepPointeX , DepPointeY, FinPointeX, FinPointeY;

	Canvas->Brush->Color = Pointe2Couleur;
	Canvas->Pen->Style = StyleLigne->Style;
        Canvas->Pen->Width = Pointe2Epaisseur;
	if (Pointe2Type == 0)
		Canvas->Brush->Style = bsSolid;
	else
		Canvas->Brush->Style = bsClear;

	switch (APosLigne)  //Poisition Par Rapport  La Ligne
	{
		case 0:
			DepPointeX = PointContactBas.X -(Pointe2Largeur / 2);
			DepPointeY = PointContactBas.Y ;
			FinPointeX = PointContactBas.X + (Pointe2Largeur/2) ;
			FinPointeY = Height;
			break;
		case 1:
			DepPointeX = PointContactDroite.X;
			DepPointeY = PointContactDroite.Y -(Pointe2Largeur / 2) ;
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe2Largeur / 2) ;
			break;
		case 2:
                        DepPointeX = PointContactDDH.X;
			DepPointeY = PointContactDDH.Y ;
			FinPointeX = Width;
			FinPointeY = 0;
			break;
		  case 3:
			DepPointeX = PointContactDDB.X;
			DepPointeY = PointContactDDB.Y ;
			FinPointeX = Width;
			FinPointeY = Height;
			break;
		  case 4:
			DepPointeX = PointContactDroite.X ;
			DepPointeY = PointContactDroite.Y -(Pointe2Largeur / 2);
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe2Largeur / 2);
			break;
		  case 5:
			DepPointeX  = PointContactHaut.X -(Pointe2Largeur / 2) ;
			DepPointeY = 0;
			FinPointeX = PointContactHaut.X +(Pointe2Largeur / 2) ;
			FinPointeY = PointContactHaut.Y ;
			break;
		  case 6:
			DepPointeX = PointContactDroite.X ;
			DepPointeY = PointContactDroite.Y -(Pointe2Largeur / 2);
			FinPointeX = Width;
			FinPointeY = PointContactDroite.Y +(Pointe2Largeur / 2);
			break;
		  case 7:
                        DepPointeX  = PointContactBas.X -(Pointe2Largeur / 2) ;
			DepPointeY = PointContactBas.Y;
			FinPointeX = PointContactBas.X +(Pointe2Largeur / 2) ;
			FinPointeY = Height ;
			break;
		  default:
			break;
	}
	TRect Form;
	Form = Rect(DepPointeX,DepPointeY,FinPointeX,FinPointeY);

	switch (Pointe2Forme)
	{
		case 0://Classic
		       	Canvas->Polygon(CreePointe(APosLigne,3),2);
			break;
		case 1://Ronde
			Canvas->Ellipse(Form);
			break;
		case 2://Carre
			Canvas->Rectangle(Form);
			break;
		case 3://Losange
			Canvas->Polygon(CreeLosange(APosLigne,3),3);
			break;
		default:
			break ;
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe1Type(TFTypePointe value)
{
	if(FPointe1Type != value) {
		FPointe1Type = value;
		StyleChange(this);
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetPointe2Type(TFTypePointe value)
{
	if(FPointe2Type != value) {
		FPointe2Type = value;
		StyleChange(this);
	}
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetOnCreate(TNotifyEvent value)
{
	if(FOnCreate != value) {
		FOnCreate = value;
	}
}
//---------------------------------------------------------------------------

__fastcall TFleches::~TFleches()
{
       delete StyleLigne ;
       delete StyleFondLigne ;
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetStyleLigne(TPen* value)
{
	FStyleLigne->Assign(value);
}
//---------------------------------------------------------------------------

void __fastcall TFleches::SetStyleFondLigne(TBrush* value)
{
	FStyleFondLigne->Assign(value);
}
//---------------------------------------------------------------------------

void __fastcall TFleches::StyleChange(TObject* Owner)
{
        Repaint();
}

void __fastcall TFleches::SiCreate(TObject *Sender)
{
	if (Owner->InheritsFrom(__classid(TWinControl)))
		Parent = dynamic_cast<TWinControl*>(Owner);
}
//---------------------------------------------------------------------------

Windows::TPoint* __fastcall TFleches::CreePointe(int APosLigne, int Place)
{
	int LaLargeur, LaLongueur;
	if (Place != 3)
	{
		LaLargeur = Pointe1Largeur;
		LaLongueur = Pointe1Longueur;
	}
	else
	{
		LaLargeur  = Pointe2Largeur;
		LaLongueur = Pointe2Longueur;
	}

	if (LaPointe)
	{
		delete[] LaPointe;
		LaPointe=NULL;
	}
	LaPointe = new Windows::TPoint[3];
	AnglePointe = atan((LaLargeur/2)/LaLongueur);

	//********************************
	//Place : 1 = Gauche  2 = Droite//
	if (Place == 1) //initialise la Pointe
	{
		switch (APosLigne)  //Position Par Rapport  La Ligne
		{
		  case 0:
                        LaPointe[0].x = Width / 2;
			LaPointe[0].y = 0;
			LaPointe[1].x= PointContactHaut.X + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[1].y= PointContactHaut.Y ;
			LaPointe[2].x= PointContactHaut.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactHaut.Y ;
			break;
		  case 1:
			LaPointe[0].x = 0 ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactGauche.X ;
			LaPointe[1].y= PointContactGauche.Y + floor((LaLargeur / 2) * cos(AnglePointe));//- floor(L * sin(AnglePointe));
			LaPointe[2].x= PointContactGauche.X ;
			LaPointe[2].y= PointContactGauche.Y - floor((LaLargeur / 2) * cos(AnglePointe));//- floor(L * sin(AnglePointe));break;
                        break;
		  case 2:
                        LaPointe[0].x = 0 ;
			LaPointe[0].y = Height ;
                        if (Width <= Height)
                        {
			LaPointe[1].x= PointContactDGB.X - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDGB.Y - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDGB.X + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDGB.Y + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;
                        }
                        else
                        {
                        LaPointe[1].x= PointContactDGB.X - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDGB.Y - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDGB.X + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDGB.Y + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;
                        }
			break;
		  case 3:
                        LaPointe[0].x = 0 ;
			LaPointe[0].y = 0 ;
                        if (Width <= Height)
                        {
			LaPointe[1].x= PointContactDGH.X + (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDGH.Y - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDGH.X - (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDGH.Y + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;
                        }
                        else
                        {
                        LaPointe[1].x= PointContactDGH.X + (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDGH.Y - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDGH.X - (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDGH.Y + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;
                        }
		        break;
		  case 4:
			LaPointe[0].x = Width / 2;
			LaPointe[0].y = 0;
			LaPointe[1].x= PointContactHaut.X + floor((LaLargeur / 2)* cos(AnglePointe));
			LaPointe[1].y= PointContactHaut.Y ;
			LaPointe[2].x= PointContactHaut.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactHaut.Y ;
			break;
		  case 5:
                        LaPointe[0].x = 0 ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactGauche.X ;
			LaPointe[1].y= PointContactGauche.Y + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].x= PointContactGauche.X ;
			LaPointe[2].y= PointContactGauche.Y - floor((LaLargeur / 2) * cos(AnglePointe));
			break;
		  case 6:
			LaPointe[0].x = Width / 2;
			LaPointe[0].y = Height;
			LaPointe[1].x= PointContactBas.X + floor((LaLargeur / 2)* cos(AnglePointe));
			LaPointe[1].y= PointContactBas.Y ;
			LaPointe[2].x= PointContactBas.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactBas.Y ;
			break;
		  case 7:
                        LaPointe[0].x = 0 ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactGauche.X ;
			LaPointe[1].y= PointContactGauche.Y + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].x= PointContactGauche.X ;
			LaPointe[2].y= PointContactGauche.Y - floor((LaLargeur / 2) * cos(AnglePointe));
                        break;
		  case 9:
			break;
		  default:
			break;
		}
        }
	else
	{
		switch (APosLigne)  //Poisition Par Rapport  La Ligne
		{
		  case 0:
			LaPointe[0].x = Width / 2;
			LaPointe[0].y = Height;
			LaPointe[1].x= PointContactBas.X + floor((LaLargeur / 2)* cos(AnglePointe));
			LaPointe[1].y= PointContactBas.Y ;
			LaPointe[2].x= PointContactBas.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactBas.Y ;
			break;
		  case 1:
			LaPointe[0].x = Width ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactDroite.X ;
			LaPointe[1].y= PointContactDroite.Y + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].x= PointContactDroite.X ;
			LaPointe[2].y= PointContactDroite.Y - floor((LaLargeur / 2) * cos(AnglePointe));
                        break;
		  case 2:
                        LaPointe[0].x = Width ;
			LaPointe[0].y = 0 ;
                        if (Width <= Height)
                        {
			LaPointe[1].x= PointContactDDH.X - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDDH.Y - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDDH.X + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDDH.Y + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;
                        }
                        else
                        {
                        LaPointe[1].x= PointContactDDH.X - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDDH.Y - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDDH.X + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDDH.Y + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;
                        }
			break;
		  case 3:
                        LaPointe[0].x = Width ;
			LaPointe[0].y = Height ;
                        if (Width <= Height)
                        {
			LaPointe[1].x= PointContactDDB.X + (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDDB.Y - (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDDB.X - (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDDB.Y + (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;
                        }
                        else
                        {
                        LaPointe[1].x= PointContactDDB.X + (LaLargeur / 2) * cos(AngleLigne - AnglePointe) ;
			LaPointe[1].y= PointContactDDB.Y - (LaLargeur / 2) * sin(AngleLigne - AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].x= PointContactDDB.X - (LaLargeur / 2) * cos(AngleLigne + AnglePointe) ;//+ (LaLargeur / 2);
			LaPointe[2].y= PointContactDDB.Y + (LaLargeur / 2) * sin(AngleLigne + AnglePointe) ;
                        }
			break;
		  case 4:
			LaPointe[0].x = Width ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactDroite.X ;
			LaPointe[1].y= PointContactDroite.Y + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].x= PointContactDroite.X ;
			LaPointe[2].y= PointContactDroite.Y - floor((LaLargeur / 2) * cos(AnglePointe));
                        break;
		  case 5:
			LaPointe[0].x = Width / 2;
			LaPointe[0].y = 0;
			LaPointe[1].x= PointContactHaut.X + floor((LaLargeur / 2)* cos(AnglePointe));
			LaPointe[1].y= PointContactHaut.Y ;
			LaPointe[2].x= PointContactHaut.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactHaut.Y ;
			break;
		  case 6:
			LaPointe[0].x = Width ;
			LaPointe[0].y = Height / 2 ;
			LaPointe[1].x= PointContactDroite.X ;
			LaPointe[1].y= PointContactDroite.Y + floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].x= PointContactDroite.X ;
			LaPointe[2].y= PointContactDroite.Y - floor((LaLargeur / 2) * cos(AnglePointe));
                        break;
		  case 7:
                        LaPointe[0].x = Width / 2;
			LaPointe[0].y = Height;
			LaPointe[1].x= PointContactBas.X + floor((LaLargeur / 2)* cos(AnglePointe));
			LaPointe[1].y= PointContactBas.Y ;
			LaPointe[2].x= PointContactBas.X - floor((LaLargeur / 2) * cos(AnglePointe));
			LaPointe[2].y= PointContactBas.Y ;
			break;
		  case 9:
			break;
		  default:
			break;
		}
	}
	return LaPointe;
}
//---------------------------------------------------------------------------

Windows::TPoint* __fastcall TFleches::CreeLosange(int APosLigne, int Place)
{
	float AngleA, AngleB, N, L;
	int LaLargeur, LaLongueur;
	if (Place != 3)
	{
		LaLargeur = Pointe1Largeur;
		LaLongueur = Pointe1Longueur;
	}
	else
	{
		LaLargeur = Pointe2Largeur;
		LaLongueur = Pointe2Longueur;
	}
	if (LaPointe2)
	{
		delete[] LaPointe2;
		LaPointe2=NULL;
	}
	LaPointe2 = new Windows::TPoint[4];
        AnglePointe = atan((LaLargeur/2)/LaLongueur);
        //********************************
	//Place : 1 = Gauche  2 = Droite//
	if (Place == 1)             //initialise la forme
	{
		switch (APosLigne)  //Position Par Rapport  La Ligne
		{
		  case 0:
			LaPointe2[0].x = PointContactHaut.X;
			LaPointe2[0].y = 0 ;
			LaPointe2[1].x = PointContactHaut.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactHaut.Y - (LaLongueur/2);
			LaPointe2[2].x = PointContactHaut.X ;
			LaPointe2[2].y = PointContactHaut.Y  ;
			LaPointe2[3].x = PointContactHaut.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactHaut.Y - (LaLongueur/2);
			break;
		  case 1:
			LaPointe2[0].x = 0;
			LaPointe2[0].y = PointContactGauche.Y ;
			LaPointe2[1].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[1].y = PointContactGauche.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactGauche.X ;
			LaPointe2[2].y = PointContactGauche.Y ;
			LaPointe2[3].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[3].y = PointContactGauche.Y - (LaLargeur/2);
			break;
		  case 2:
                        LaPointe2[0].x = 0 ;
			LaPointe2[0].y = Height ;
                        LaPointe2[2].x= PointContactDGB.X ;
			LaPointe2[2].y= PointContactDGB.Y ;
                        if (Width <= Height)
                        {
                        LaPointe2[1].x= (((LaLongueur / 2)* cos(AngleLigne))) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[1].y= (Height-((LaLongueur / 2)* sin(AngleLigne))) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[3].x= (((LaLongueur / 2)* cos(AngleLigne))) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
			LaPointe2[3].y= (Height-((LaLongueur / 2)* sin(AngleLigne))) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			}
                        else
                        {
                        LaPointe2[1].x= (((LaLongueur / 2))* sin(AngleLigne)) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[1].y= (Height -((LaLongueur / 2))* cos(AngleLigne)) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[3].x= (((LaLongueur / 2))* sin(AngleLigne)) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			LaPointe2[3].y= (Height -((LaLongueur / 2))* cos(AngleLigne)) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
                        }
                        break;
		  case 3:
                        LaPointe2[0].x = 0 ;
			LaPointe2[0].y = 0 ;
                        LaPointe2[2].x= PointContactDGH.X ;
			LaPointe2[2].y= PointContactDGH.Y ;
                        if (Width <= Height)
                        {
			LaPointe2[1].x= ((LaLongueur / 2)* cos(AngleLigne)) + (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[1].y= ((LaLongueur / 2)* sin(AngleLigne)) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[3].x= ((LaLongueur / 2)* cos(AngleLigne)) - (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
			LaPointe2[3].y= ((LaLongueur / 2)* sin(AngleLigne)) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
                        }
                        else
                        {
                        LaPointe2[1].x= ((LaLongueur / 2)* sin(AngleLigne)) + (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[1].y= ((LaLongueur / 2)* cos(AngleLigne)) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[3].x= ((LaLongueur / 2)* sin(AngleLigne)) - (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			LaPointe2[3].y= ((LaLongueur / 2)* cos(AngleLigne)) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
                        }
                        break;
		  case 4:
			LaPointe2[0].x = PointContactHaut.X;
			LaPointe2[0].y = 0 ;
			LaPointe2[1].x = PointContactHaut.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactHaut.Y - (LaLongueur/2);
			LaPointe2[2].x = PointContactHaut.X ;
			LaPointe2[2].y = PointContactHaut.Y  ;
			LaPointe2[3].x = PointContactHaut.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactHaut.Y - (LaLongueur/2);
			break;
		  case 5:
			LaPointe2[0].x = 0;
			LaPointe2[0].y = PointContactGauche.Y ;
			LaPointe2[1].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[1].y = PointContactGauche.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactGauche.X ;
			LaPointe2[2].y = PointContactGauche.Y ;
			LaPointe2[3].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[3].y = PointContactGauche.Y - (LaLargeur/2);
			break;
		  case 6:
			LaPointe2[0].x = PointContactBas.X;
			LaPointe2[0].y = Height ;
			LaPointe2[1].x = PointContactBas.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactBas.Y + (LaLongueur/2);
			LaPointe2[2].x = PointContactBas.X ;
			LaPointe2[2].y = PointContactBas.Y  ;
			LaPointe2[3].x = PointContactBas.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactBas.Y + (LaLongueur/2);
			break;
		  case 7:
			LaPointe2[0].x = 0;
			LaPointe2[0].y = PointContactGauche.Y ;
			LaPointe2[1].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[1].y = PointContactGauche.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactGauche.X ;
			LaPointe2[2].y = PointContactGauche.Y ;
			LaPointe2[3].x = PointContactGauche.X - (LaLongueur/2);
			LaPointe2[3].y = PointContactGauche.Y - (LaLargeur/2);
			break;
		  default:
			break;
		}

	}
	else
	{
		switch (APosLigne)  //Poisition Par Rapport  La Ligne
		{
		  case 0:
			LaPointe2[0].x = PointContactBas.X;
			LaPointe2[0].y = Height ;
			LaPointe2[1].x = PointContactBas.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactBas.Y + (LaLongueur/2);
			LaPointe2[2].x = PointContactBas.X ;
			LaPointe2[2].y = PointContactBas.Y  ;
			LaPointe2[3].x = PointContactBas.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactBas.Y + (LaLongueur/2);
			break;
		  case 1:
			LaPointe2[0].x = Width;
			LaPointe2[0].y = PointContactDroite.Y ;
			LaPointe2[1].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[1].y = PointContactDroite.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactDroite.X ;
			LaPointe2[2].y = PointContactDroite.Y ;
			LaPointe2[3].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[3].y = PointContactDroite.Y - (LaLargeur/2);
			break;
		  case 2:
                        LaPointe2[0].x = Width ;
			LaPointe2[0].y = 0 ;
                        LaPointe2[2].x= PointContactDDH.X ;
			LaPointe2[2].y= PointContactDDH.Y ;
                        if (Width <= Height)
                        {
                        LaPointe2[1].x= (Width -((LaLongueur / 2)* cos(AngleLigne))) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[1].y= (((LaLongueur / 2)* sin(AngleLigne))) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[3].x= (Width -((LaLongueur / 2)* cos(AngleLigne))) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
			LaPointe2[3].y= (((LaLongueur / 2)* sin(AngleLigne))) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			}
                        else
                        {
                        LaPointe2[1].x= (Width -((LaLongueur / 2))* sin(AngleLigne)) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[1].y= (((LaLongueur / 2))* cos(AngleLigne)) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[3].x= (Width -((LaLongueur / 2))* sin(AngleLigne)) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			LaPointe2[3].y= (((LaLongueur / 2))* cos(AngleLigne)) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
                        }
		        break;
		  case 3:
                        LaPointe2[0].x = Width ;
			LaPointe2[0].y = Height ;
                        LaPointe2[2].x= PointContactDDB.X ;
			LaPointe2[2].y= PointContactDDB.Y ;
                        if (Width <= Height)
                        {
                        LaPointe2[1].x= (Width -((LaLongueur / 2)* cos(AngleLigne))) + (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[1].y= (Height-((LaLongueur / 2)* sin(AngleLigne))) - (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[3].x= (Width -((LaLongueur / 2)* cos(AngleLigne))) - (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
			LaPointe2[3].y= (Height-((LaLongueur / 2)* sin(AngleLigne))) + (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			}
                        else
                        {
                        LaPointe2[1].x= (Width -((LaLongueur / 2))* sin(AngleLigne)) + (LaLargeur / 2) * cos(AngleLigne - AnglePointe);
			LaPointe2[1].y= (Height -((LaLongueur / 2))* cos(AngleLigne)) - (LaLargeur / 2) * sin(AngleLigne - AnglePointe);
			LaPointe2[3].x= (Width -((LaLongueur / 2))* sin(AngleLigne)) - (LaLargeur / 2) * cos(AngleLigne + AnglePointe);
			LaPointe2[3].y= (Height -((LaLongueur / 2))* cos(AngleLigne)) + (LaLargeur / 2) * sin(AngleLigne + AnglePointe);
                        }
			break;
		  case 4:
			LaPointe2[0].x = Width;
			LaPointe2[0].y = PointContactDroite.Y ;
			LaPointe2[1].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[1].y = PointContactDroite.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactDroite.X ;
			LaPointe2[2].y = PointContactDroite.Y ;
			LaPointe2[3].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[3].y = PointContactDroite.Y - (LaLargeur/2);
			break;
		  case 5:
			LaPointe2[0].x = PointContactHaut.X;
			LaPointe2[0].y = 0 ;
			LaPointe2[1].x = PointContactHaut.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactHaut.Y - (LaLongueur/2);
			LaPointe2[2].x = PointContactHaut.X ;
			LaPointe2[2].y = PointContactHaut.Y  ;
			LaPointe2[3].x = PointContactHaut.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactHaut.Y - (LaLongueur/2);
			break;
		  case 6:
			LaPointe2[0].x = Width;
			LaPointe2[0].y = PointContactDroite.Y ;
			LaPointe2[1].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[1].y = PointContactDroite.Y + (LaLargeur/2);
			LaPointe2[2].x = PointContactDroite.X ;
			LaPointe2[2].y = PointContactDroite.Y ;
			LaPointe2[3].x = PointContactDroite.X + (LaLongueur/2);
			LaPointe2[3].y = PointContactDroite.Y - (LaLargeur/2);
			break;
		  case 7:
			LaPointe2[0].x = PointContactBas.X;
			LaPointe2[0].y = Height ;
			LaPointe2[1].x = PointContactBas.X - (LaLargeur/2);
			LaPointe2[1].y = PointContactBas.Y + (LaLongueur/2);
			LaPointe2[2].x = PointContactBas.X ;
			LaPointe2[2].y = PointContactBas.Y  ;
			LaPointe2[3].x = PointContactBas.X + (LaLargeur/2);
			LaPointe2[3].y = PointContactBas.Y + (LaLongueur/2);
			break;
                  default:
			break;
		}
	}
	return LaPointe2;
}
//---------------------------------------------------------------------------
/*
void __fastcall TFleches::SetVisible(bool value)
{
        if(FVisible != value) {
                FVisible = value;

        }
}   */

void __fastcall TFleches::ActionUpdate(TObject * Sender)
{
        //A FAIRE : Ajoutez votre code ici
}
